-------------------------------------------------------
-- Local Variables
-------------------------------------------------------
local DM = "DeggansMarks"  -- DM Title
local DMF = "DeggansMarksFlares"   -- DMFlares Title
local versionNum = GetAddOnMetadata("DeggansMarks", "Version")
local curVer = versionNum      -- Version Number

-------------------------------------------------------
-- Default variables
-------------------------------------------------------
Defaults = {
	shown = true,
	vertical = false,
	locked = true,
	clamped = true,
	tooltips = false,
	backgroundHide = false,
	disabled = false,
	markerScale = 1,
	flareScale = 1,
	buttonScale = 1,
	buttonsEnabled = true,
}

local isPullTimerStarted = false
local playerOutOfCombat = true
_,_,_,isEnabledDBM,_,_,_ = GetAddOnInfo("DBM-Core")
_,_,_,isEnabledBigWigs,_,_,_ = GetAddOnInfo("BigWigs")
_,_,_,isEnabledVEM,_,_,_ = GetAddOnInfo("VEM-Core")

if (isEnabledDBM) then
	textPrefix = "/dbm "
elseif (isEnabledBigWigs) then
	textPrefix = "/"
elseif (isEnabledVEM) then
	textPrefix = "/vem "
end

-------------------------------------------------------
-- backdrops for frame
-------------------------------------------------------
local defaultBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
}
local borderlessBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	tile = true,
	tileSize = 16
}

local editBoxBackdrop = {
	bgFile = "Interface\\COMMON\\Common-Input-Border",
	tile = false,
}

-------------------------------------------------------
-- Main frames
-------------------------------------------------------
DM_mainFrame = CreateFrame("Frame", "DM_mainFrame", UIParent)
DM_mainFrame:SetBackdrop(borderlessBackdrop)
DM_mainFrame:SetBackdropColor(0,0,0,0)
DM_mainFrame:EnableMouse(true)
DM_mainFrame:SetMovable(true)
DM_mainFrame:SetSize(190,35)
DM_mainFrame:SetPoint("TOP", UIParent, "TOP")
DM_mainFrame:SetClampedToScreen(true)


-------------------------------------------------------
-- DM Icon Frame and Icons
-------------------------------------------------------
local DM_IconFrame = CreateFrame("Frame", "DM_IconFrame", DM_mainFrame)
DM_IconFrame:SetBackdrop(defaultBackdrop)
DM_IconFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
DM_IconFrame:EnableMouse(true)
DM_IconFrame:SetMovable(true)
DM_IconFrame:SetSize(190,35)
DM_IconFrame:SetPoint("LEFT", DM_mainFrame, "LEFT")
DM_IconFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton" and Defaults.locked == false) then DM_mainFrame:StartMoving() end end)
DM_IconFrame:SetScript("OnMouseUp", function(self) DM_mainFrame:StopMovingOrSizing() end)

local DM_IconSkull = CreateFrame("Button", "DM_IconSkull", DM_IconFrame)
DM_IconSkull:SetSize(20,20)
DM_IconSkull:SetPoint("LEFT", DM_IconFrame, "LEFT",5,0)
DM_IconSkull:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconSkull:GetNormalTexture():SetTexCoord(0.75,1,0.25,0.5)
DM_IconSkull:EnableMouse(true)
DM_IconSkull:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 8) end)

local DM_IconCross = CreateFrame("Button", "DM_IconCross", DM_IconFrame)
DM_IconCross:SetSize(20,20)
DM_IconCross:SetPoint("LEFT", DM_IconSkull, "RIGHT")
DM_IconCross:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconCross:GetNormalTexture():SetTexCoord(0.5,0.75,0.25,0.5)
DM_IconCross:EnableMouse(true)
DM_IconCross:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 7) end)

local DM_IconSquare = CreateFrame("Button", "DM_IconSquare", DM_IconFrame)
DM_IconSquare:SetSize(20,20)
DM_IconSquare:SetPoint("LEFT", DM_IconCross, "RIGHT")
DM_IconSquare:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconSquare:GetNormalTexture():SetTexCoord(0.25,0.5,0.25,0.5)
DM_IconSquare:EnableMouse(true)
DM_IconSquare:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 6) end)

local DM_IconMoon = CreateFrame("Button", "DM_IconMoon", DM_IconFrame)
DM_IconMoon:SetSize(20,20)
DM_IconMoon:SetPoint("LEFT", DM_IconSquare, "RIGHT")
DM_IconMoon:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconMoon:GetNormalTexture():SetTexCoord(0,0.25,0.25,0.5)
DM_IconMoon:EnableMouse(true)
DM_IconMoon:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 5) end)

local DM_IconTriangle = CreateFrame("Button", "DM_IconTriangle", DM_IconFrame)
DM_IconTriangle:SetSize(20,20)
DM_IconTriangle:SetPoint("LEFT", DM_IconMoon, "RIGHT")
DM_IconTriangle:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconTriangle:GetNormalTexture():SetTexCoord(0.75,1,0,0.25)
DM_IconTriangle:EnableMouse(true)
DM_IconTriangle:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 4) end)

local DM_IconDiamond = CreateFrame("Button", "DM_IconDiamond", DM_IconFrame)
DM_IconDiamond:SetSize(20,20)
DM_IconDiamond:SetPoint("LEFT", DM_IconTriangle, "RIGHT")
DM_IconDiamond:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconDiamond:GetNormalTexture():SetTexCoord(0.5,0.75,0,0.25)
DM_IconDiamond:EnableMouse(true)
DM_IconDiamond:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 3) end)

local DM_IconCircle = CreateFrame("Button", "DM_IconCircle", DM_IconFrame)
DM_IconCircle:SetSize(20,20)
DM_IconCircle:SetPoint("LEFT", DM_IconDiamond, "RIGHT")
DM_IconCircle:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconCircle:GetNormalTexture():SetTexCoord(0.25,0.5,0,0.25)
DM_IconCircle:EnableMouse(true)
DM_IconCircle:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 2) end)

local DM_IconStar = CreateFrame("Button", "DM_IconStar", DM_IconFrame)
DM_IconStar:SetSize(20,20)
DM_IconStar:SetPoint("LEFT", DM_IconCircle, "RIGHT")
DM_IconStar:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingIcons")
DM_IconStar:GetNormalTexture():SetTexCoord(0,0.25,0,0.25)
DM_IconStar:EnableMouse(true)
DM_IconStar:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 1) end)

local DM_LockIcon = CreateFrame("Button", "DM_LockIcon", DM_IconFrame)
DM_LockIcon:SetSize(20,20)
DM_LockIcon:SetPoint("LEFT", DM_IconStar , "RIGHT")
DM_LockIcon:SetNormalTexture("Interface\\GLUES\\CharacterSelect\\Glues-Addon-Icons")
DM_LockIcon:GetNormalTexture():SetTexCoord(0, 0.25, 0, 1)
DM_LockIcon:EnableMouse(true)
DM_LockIcon:SetScript("OnClick", function(self) DM_lockToggle() end)
--Used as a debug button
--DM_LockIcon:SetScript("OnClick", function(self) name,_,_,isEnabled,_,_,_ = GetAddOnInfo("DBM-Cores") SendChatMessage(isEnabled) end)

-------------------------------------------------------
-- DM_Flares Main Frame and Movers
-------------------------------------------------------

DM_Flares_mainFrame = CreateFrame("Frame", "DM_Flares_mainFrame", UIParent)
DM_Flares_mainFrame:SetBackdrop(borderlessBackdrop)
DM_Flares_mainFrame:SetBackdropColor(0,0,0,0)
DM_Flares_mainFrame:EnableMouse(true)
DM_Flares_mainFrame:SetMovable(true)
DM_Flares_mainFrame:SetSize(230,35)
DM_Flares_mainFrame:SetPoint("TOP", UIParent, "TOP",0,-40)
DM_Flares_mainFrame:SetClampedToScreen(true)

-------------------------------------------------------
-- The DM_Flare Frame and DM_Flares
-------------------------------------------------------
local DM_FlareFrame = CreateFrame("Frame", "DM_FlareFrame", DM_Flares_mainFrame)
DM_FlareFrame:SetBackdrop(defaultBackdrop)
DM_FlareFrame:SetBackdropColor(0.1,0.1,0.1,0.1,0.7)
DM_FlareFrame:EnableMouse(true)
DM_FlareFrame:SetMovable(true)
DM_FlareFrame:SetSize(230,35)
DM_FlareFrame:SetPoint("LEFT", DM_Flares_mainFrame, "LEFT")
DM_FlareFrame:SetClampedToScreen(true)
DM_FlareFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton" and Defaults.locked == false) then DM_Flares_mainFrame:StartMoving() end end)
DM_FlareFrame:SetScript("OnMouseUp", function(self) DM_Flares_mainFrame:StopMovingOrSizing() end)

local DM_FlareWhite = CreateFrame("Button", "DM_FlareWhite", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareWhite:SetSize(25,25)
DM_FlareWhite:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareWhite:GetNormalTexture():SetTexCoord(0.5,0.625,0,0.25)
DM_FlareWhite:SetPoint("TOPLEFT", DM_FlareFrame, "TOPLEFT",5,-5)
DM_FlareWhite:SetAttribute("type", "macro")
DM_FlareWhite:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button1")

local DM_FlareRed = CreateFrame("Button", "DM_FlareRed", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareRed:SetSize(25,25)
DM_FlareRed:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareRed:GetNormalTexture():SetTexCoord(0.625,0.75,0,0.25)
DM_FlareRed:SetPoint("LEFT", DM_FlareWhite, "RIGHT")
DM_FlareRed:SetAttribute("type", "macro")
DM_FlareRed:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button2")

local DM_FlareBlue = CreateFrame("Button", "DM_FlareBlue", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareBlue:SetSize(25,25)
DM_FlareBlue:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareBlue:GetNormalTexture():SetTexCoord(0.75,0.875,0,0.25)
DM_FlareBlue:SetPoint("LEFT", DM_FlareRed, "RIGHT")
DM_FlareBlue:SetAttribute("type", "macro")
DM_FlareBlue:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button3")

local DM_FlareSilver = CreateFrame("Button", "DM_FlareSilver", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareSilver:SetSize(25,25)
DM_FlareSilver:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareSilver:GetNormalTexture():SetTexCoord(0.875,1,0,0.25)
DM_FlareSilver:SetPoint("LEFT", DM_FlareBlue, "RIGHT")
DM_FlareSilver:SetAttribute("type", "macro")
DM_FlareSilver:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button4")

local DM_FlareGreen = CreateFrame("Button", "DM_FlareGreen", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareGreen:SetSize(25,25)
DM_FlareGreen:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareGreen:GetNormalTexture():SetTexCoord(0.25,0.375,0,0.25)
DM_FlareGreen:SetPoint("LEFT", DM_FlareSilver, "RIGHT")
DM_FlareGreen:SetAttribute("type", "macro")
DM_FlareGreen:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button5")

local DM_FlarePurple = CreateFrame("Button", "DM_FlarePurple", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlarePurple:SetSize(25,25)
DM_FlarePurple:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlarePurple:GetNormalTexture():SetTexCoord(0,0.125,0.25,0.5)
DM_FlarePurple:SetPoint("LEFT", DM_FlareGreen, "RIGHT")
DM_FlarePurple:SetAttribute("type", "macro")
DM_FlarePurple:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button6")

local DM_FlareOrange = CreateFrame("Button", "DM_FlareOrange", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareOrange:SetSize(25,25)
DM_FlareOrange:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareOrange:GetNormalTexture():SetTexCoord(0.25,0.375,0.25,0.5)
DM_FlareOrange:SetPoint("LEFT", DM_FlarePurple, "RIGHT")
DM_FlareOrange:SetAttribute("type", "macro")
DM_FlareOrange:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button7")

local DM_FlareYellow = CreateFrame("Button", "DM_FlareYellow", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareYellow:SetSize(25,25)
DM_FlareYellow:SetNormalTexture("interface\\minimap\\partyraidblips")
DM_FlareYellow:GetNormalTexture():SetTexCoord(0.375,0.5,0,0.25)
DM_FlareYellow:SetPoint("LEFT", DM_FlareOrange, "RIGHT")
DM_FlareYellow:SetAttribute("type", "macro")
DM_FlareYellow:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button8")

local DM_FlareClear = CreateFrame("Button", "DM_FlareClear", DM_FlareFrame, "SecureActionButtonTemplate")
DM_FlareClear:SetSize(15,15)
DM_FlareClear:SetNormalTexture("interface\\glues\\loadingscreens\\dynamicelements")
DM_FlareClear:GetNormalTexture():SetTexCoord(0,0.5,0,0.5)
DM_FlareClear:SetPoint("LEFT", DM_FlareYellow, "RIGHT")
DM_FlareClear:SetAttribute("type", "macro")
DM_FlareClear:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button9")


-------------------------------------------------------
-- Readycheck and dbm buttons
-------------------------------------------------------

DM_Console_mainFrame = CreateFrame("Frame", "DM_Console_mainFrame", UIParent)
DM_Console_mainFrame:SetBackdrop(borderlessBackdrop)
DM_Console_mainFrame:SetBackdropColor(0,0,0,0)
DM_Console_mainFrame:EnableMouse(true)
DM_Console_mainFrame:SetMovable(true)
DM_Console_mainFrame:SetSize(81,84)
DM_Console_mainFrame:SetPoint("TOP", UIParent, "TOP",0,-40)
DM_Console_mainFrame:SetClampedToScreen(true)

-------------------------------------------------------
-- The DM_Flare Frame and DM_Flares
-------------------------------------------------------
local DM_ConsoleFrame = CreateFrame("Frame", "DM_ConsoleFrame", DM_Console_mainFrame)
DM_ConsoleFrame:SetBackdrop(defaultBackdrop)
DM_ConsoleFrame:SetBackdropColor(0.1,0.1,0.1,0.1,0.7)
DM_ConsoleFrame:EnableMouse(true)
DM_ConsoleFrame:SetMovable(true)
DM_ConsoleFrame:SetSize(81,84)
DM_ConsoleFrame:SetPoint("LEFT", DM_Console_mainFrame, "LEFT")
DM_ConsoleFrame:SetClampedToScreen(true)
DM_ConsoleFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton" and Defaults.locked == false) then DM_Console_mainFrame:StartMoving() end end)
DM_ConsoleFrame:SetScript("OnMouseUp", function(self) DM_Console_mainFrame:StopMovingOrSizing() end)

local DM_ReadyCheck = CreateFrame("Button", "DM_ReadyCheck", DM_ConsoleFrame, "SecureActionButtonTemplate")
DM_ReadyCheck:SetSize(81,26)
DM_ReadyCheck:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\ReadyCheckUp")
DM_ReadyCheck:GetNormalTexture():SetTexCoord(0,1,0,1)
DM_ReadyCheck:SetPoint("TOP", DM_ConsoleFrame, "TOP",0,0)
DM_ReadyCheck:EnableMouse(true)
DM_ReadyCheck:SetAttribute("type", "macro")
DM_ReadyCheck:SetAttribute("macrotext1", "/readycheck")
DM_ReadyCheck:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then DM_ReadyCheck:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\ReadyCheckDown") end end)
DM_ReadyCheck:SetScript("OnMouseUp", function(self) DM_ReadyCheck:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\ReadyCheckUp") end)

local DM_PullTen = CreateFrame("Button", "DM_PullTen", DM_ReadyCheck, "SecureActionButtonTemplate")
DM_PullTen:SetSize(81,26)
DM_PullTen:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TenButtonUp")
DM_PullTen:GetNormalTexture():SetTexCoord(0,1,0,1)
DM_PullTen:SetPoint("TOP", DM_ReadyCheck, "BOTTOM",0,0)
DM_PullTen:EnableMouse(true)
DM_PullTen:SetAttribute("type", "macro")
DM_PullTen:SetAttribute("macrotext1", textPrefix.."pull 10")
DM_PullTen:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then DM_PullTen:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TenButtonDown") end end)
DM_PullTen:SetScript("OnMouseUp", function(self) DM_PullTen:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TenButtonUp") DM_controlCancel() end)
	
local DM_PullTwenty = CreateFrame("Button", "DM_PullTwenty", DM_PullTen, "SecureActionButtonTemplate")
DM_PullTwenty:SetSize(81,26)
DM_PullTwenty:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TwentyButtonUp")
DM_PullTwenty:GetNormalTexture():SetTexCoord(0,1,0,1)
DM_PullTwenty:SetPoint("TOP", DM_PullTen, "BOTTOM",0,0)
DM_PullTwenty:EnableMouse(true)
DM_PullTwenty:SetAttribute("type", "macro")
DM_PullTwenty:SetAttribute("macrotext1", textPrefix.."pull 20")
DM_PullTwenty:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then DM_PullTwenty:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TwentyButtonDown") end end)
DM_PullTwenty:SetScript("OnMouseUp", function(self) DM_PullTwenty:SetNormalTexture("Interface\\AddOns\\DeggansMarks\\Media\\TwentyButtonUp") DM_controlCancel() end)

-------------------------------------------------------
-- Functions
-------------------------------------------------------
function DM_controlCancel()
	if playerOutOfCombat == true then
		if isPullTimerStarted == true then
			DM_PullTen:SetAttribute("macrotext1", textPrefix.."pull 0")
			DM_PullTwenty:SetAttribute("macrotext1", textPrefix.."pull 0")
			SendChatMessage("PULL TIMER CANCELLED", "RAID_WARNING")
			isPullTimerStarted = false
		elseif isPullTimerStarted == false then
			DM_PullTen:SetAttribute("macrotext1", textPrefix.."pull 10")
			DM_PullTwenty:SetAttribute("macrotext1", textPrefix.."pull 20")
			isPullTimerStarted = true
		end
	end
end
function DM_lock()
    Defaults.locked = true
	DM_mainFrame:EnableMouse(false)
	DM_mainFrame:SetMovable(false)
    DM_LockIcon:GetNormalTexture():SetTexCoord(0, 0.25, 0, 1)
end

function DM_unlock()
    Defaults.locked = false
	DM_mainFrame:EnableMouse(true)
	DM_mainFrame:SetMovable(true)
    DM_LockIcon:GetNormalTexture():SetTexCoord(0.25, 0.50, 0, 1)
end

function DM_lockToggle()
    if Defaults.locked then DM_unlock("main") else DM_lock("main") end
end   

function DM_scale(self, DB)
	if self == nil then return end
	if DB == "main" then
		Defaults.markerScale = (self:GetValue())
		getglobal(self:GetName().."Text"):SetText("Marker scale: "..math.floor((Defaults.markerScale*100)).."%")
		DM_mainFrame:SetScale(Defaults.markerScale)
	elseif DB == "flare" then
		Defaults.flareScale = (self:GetValue())
		getglobal(self:GetName().."Text"):SetText("Flares scale: "..math.floor((Defaults.flareScale*100)).."%")
		DM_Flares_mainFrame:SetScale(Defaults.flareScale)
	end
end

function DM_backgroundChange()
	if Defaults.backgroundHide == true then
		DM_IconFrame:SetBackdropColor(0,0,0,0)
		DM_IconFrame:SetBackdropBorderColor(0,0,0,0)
		DM_FlareFrame:SetBackdropColor(0,0,0,0)
		DM_FlareFrame:SetBackdropBorderColor(0,0,0,0)
	elseif Defaults.backgroundHide == false then
		DM_IconFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
		DM_IconFrame:SetBackdropBorderColor(1,1,1,1)
		DM_FlareFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
		DM_FlareFrame:SetBackdropBorderColor(1,1,1,1)
	end
end

function DM_makeVertical()
	DM_IconSkull:ClearAllPoints()
	DM_IconCross:ClearAllPoints()
	DM_IconSquare:ClearAllPoints()
	DM_IconMoon:ClearAllPoints()
	DM_IconTriangle:ClearAllPoints()
	DM_IconDiamond:ClearAllPoints()
	DM_IconCircle:ClearAllPoints()
	DM_IconStar:ClearAllPoints()
	DM_LockIcon:ClearAllPoints()
	DM_IconFrame:ClearAllPoints()
	
	DM_FlareWhite:ClearAllPoints()
	DM_FlareRed:ClearAllPoints()
	DM_FlareBlue:ClearAllPoints()
	DM_FlareSilver:ClearAllPoints()
	DM_FlareGreen:ClearAllPoints()
	DM_FlarePurple:ClearAllPoints()
	DM_FlareOrange:ClearAllPoints()
	DM_FlareYellow:ClearAllPoints()
	DM_FlareClear:ClearAllPoints()
	DM_FlareFrame:ClearAllPoints()
	
	if Defaults.vertical == true then
		DM_IconSkull:SetPoint("TOP", DM_IconFrame, "TOP",0,-5)
		DM_IconCross:SetPoint("TOP", DM_IconSkull, "BOTTOM")
		DM_IconSquare:SetPoint("TOP", DM_IconCross, "BOTTOM")
		DM_IconMoon:SetPoint("TOP", DM_IconSquare, "BOTTOM")
		DM_IconTriangle:SetPoint("TOP", DM_IconMoon, "BOTTOM")
		DM_IconDiamond:SetPoint("TOP", DM_IconTriangle, "BOTTOM")
		DM_IconCircle:SetPoint("TOP", DM_IconDiamond, "BOTTOM")
		DM_IconStar:SetPoint("TOP", DM_IconCircle, "BOTTOM")
		DM_LockIcon:SetPoint("TOP", DM_IconStar , "BOTTOM")
		DM_mainFrame:SetSize(35,190)
		DM_IconFrame:SetSize(35,190)
		DM_IconFrame:SetPoint("TOP", DM_mainFrame, "TOP")
	
		DM_FlareWhite:SetPoint("TOPLEFT", DM_FlareFrame, "TOPLEFT",4,-5)
		DM_FlareRed:SetPoint("TOP", DM_FlareWhite, "BOTTOM")
		DM_FlareBlue:SetPoint("TOP", DM_FlareRed, "BOTTOM")
		DM_FlareSilver:SetPoint("TOP", DM_FlareBlue, "BOTTOM")
		DM_FlareGreen:SetPoint("TOP", DM_FlareSilver, "BOTTOM")
		DM_FlarePurple:SetPoint("TOP", DM_FlareGreen, "BOTTOM")
		DM_FlareOrange:SetPoint("TOP", DM_FlarePurple, "BOTTOM")
		DM_FlareYellow:SetPoint("TOP", DM_FlareOrange, "BOTTOM")
		DM_FlareClear:SetPoint("TOP", DM_FlareYellow, "BOTTOM",0,-3)
		DM_Flares_mainFrame:SetSize(35,180)
		DM_FlareFrame:SetSize(35,230)
		DM_FlareFrame:SetPoint("TOP", DM_Flares_mainFrame, "TOP")
		
	elseif Defaults.vertical == false then
		DM_IconSkull:SetPoint("LEFT", DM_IconFrame, "LEFT",5,0)
		DM_IconCross:SetPoint("LEFT", DM_IconSkull, "RIGHT")
		DM_IconSquare:SetPoint("LEFT", DM_IconCross, "RIGHT")
		DM_IconMoon:SetPoint("LEFT", DM_IconSquare, "RIGHT")
		DM_IconTriangle:SetPoint("LEFT", DM_IconMoon, "RIGHT")
		DM_IconDiamond:SetPoint("LEFT", DM_IconTriangle, "RIGHT")
		DM_IconCircle:SetPoint("LEFT", DM_IconDiamond, "RIGHT")
		DM_IconStar:SetPoint("LEFT", DM_IconCircle, "RIGHT")
		DM_LockIcon:SetPoint("LEFT", DM_IconStar , "RIGHT")
		DM_mainFrame:SetSize(190,35)
		DM_IconFrame:SetSize(190,35)
		DM_IconFrame:SetPoint("LEFT", DM_mainFrame, "LEFT")
	
		DM_FlareWhite:SetPoint("TOPLEFT", DM_FlareFrame, "TOPLEFT",4,-5)
		DM_FlareRed:SetPoint("LEFT", DM_FlareWhite, "RIGHT")
		DM_FlareBlue:SetPoint("LEFT", DM_FlareRed, "RIGHT")
		DM_FlareSilver:SetPoint("LEFT", DM_FlareBlue, "RIGHT")
		DM_FlareGreen:SetPoint("LEFT", DM_FlareSilver, "RIGHT")
		DM_FlarePurple:SetPoint("LEFT", DM_FlareGreen, "RIGHT")
		DM_FlareOrange:SetPoint("LEFT", DM_FlarePurple, "RIGHT")
		DM_FlareYellow:SetPoint("LEFT", DM_FlareOrange, "RIGHT")
		DM_FlareClear:SetPoint("LEFT", DM_FlareYellow, "RIGHT",3,0)
		DM_Flares_mainFrame:SetSize(180,35)
		DM_FlareFrame:SetSize(230,35)
		DM_FlareFrame:SetPoint("LEFT", DM_Flares_mainFrame, "LEFT")
	end
end

function DM_disable()
	if Defaults.disabled == true then
		DM_IconSkull:Hide()
		DM_IconCross:Hide()
		DM_IconSquare:Hide()
		DM_IconMoon:Hide()
		DM_IconTriangle:Hide()
		DM_IconDiamond:Hide()
		DM_IconCircle:Hide()
		DM_IconStar:Hide()
		DM_LockIcon:Hide()
		DM_IconFrame:Hide()
	
		DM_FlareWhite:Hide()
		DM_FlareRed:Hide()
		DM_FlareBlue:Hide()
		DM_FlareSilver:Hide()
		DM_FlareGreen:Hide()
		DM_FlarePurple:Hide()
		DM_FlareOrange:Hide()
		DM_FlareYellow:Hide()
		DM_FlareClear:Hide()
		DM_FlareFrame:Hide()
		
		DM_ConsoleFrame:Hide()
		DM_ReadyCheck:Hide()
		DM_PullTen:Hide()
		DM_PullTwenty:Hide()
		
	elseif Defaults.disabled == false then
		DM_IconSkull:Show()
		DM_IconCross:Show()
		DM_IconSquare:Show()
		DM_IconMoon:Show()
		DM_IconTriangle:Show()
		DM_IconDiamond:Show()
		DM_IconCircle:Show()
		DM_IconStar:Show()
		DM_LockIcon:Show()
		DM_IconFrame:Show()
	
		DM_FlareWhite:Show()
		DM_FlareRed:Show()
		DM_FlareBlue:Show()
		DM_FlareSilver:Show()
		DM_FlareGreen:Show()
		DM_FlarePurple:Show()
		DM_FlareOrange:Show()
		DM_FlareYellow:Show()
		DM_FlareClear:Show()
		DM_FlareFrame:Show()
		
		DM_ConsoleFrame:Show()
		DM_ReadyCheck:Show()
		DM_PullTen:Show()
		DM_PullTwenty:Show()
	end
end

function DM_SavePositions()
	local f_ap, _, _, f_x, f_y = DM_Flares_mainFrame:GetPoint()
	local m_ap, _, _, m_x, m_y = DM_mainFrame:GetPoint()
	Defaults.FlaresAP = f_ap
	Defaults.FlaresX = f_x
	Defaults.FlaresY = f_y	
	Defaults.MarkersAP = m_ap
	Defaults.MarkersX = m_x
	Defaults.MarkersY = m_y
end

function DM_SetPositions()
	if (Defaults.MarkersX ~= nil) then
		DM_mainFrame:ClearAllPoints()
		DM_Flares_mainFrame:ClearAllPoints()
		DM_mainFrame:SetPoint(Defaults.MarkersAP, UIParent, Defaults.MarkersX, Defaults.MarkersY)
		DM_Flares_mainFrame:SetPoint(Defaults.FlaresAP, UIParent, Defaults.FlaresX, Defaults.FlaresY)
		DM_CheckUpdater()
	end
end

function DM_CheckUpdater()
	DeggansMarksVertCheck:SetChecked(Defaults.vertical)
	if Defaults.vertical == true then
		DM_makeVertical()
	end
	DeggansMarksBackgroundCheck:SetChecked(Defaults.backgroundHide)
	if Defaults.backgroundHide == true then
		DM_backgroundChange()
	end
	DeggansMarksDisablerCheck:SetChecked(Defaults.disabled)
	if Defaults.disabled == true then
		DM_disable()
	end
	DM_mainFrame:SetScale(Defaults.markerScale);
	DM_Flares_mainFrame:SetScale(Defaults.flareScale)
end
	
-------------------------------------------------------
-- Options
-------------------------------------------------------
DeggansMarksOptions = {};
DeggansMarksOptions.panel = CreateFrame( "Frame", "DeggansMarksOptions", InterfaceOptionsFramePanelContainer );
DeggansMarksOptions.panel.name = "Deggans Marks";
InterfaceOptions_AddCategory(DeggansMarksOptions.panel);

local DeggansMarksOptionsTitle = DeggansMarksOptions.panel:CreateFontString("DeggansMarksOptionsTitle", "OVERLAY", "ChatFontNormal")
DeggansMarksOptionsTitle:SetPoint("TOP", DeggansMarksOptions.panel, "TOP",0,-10) 
DeggansMarksOptionsTitle:SetText("|cffe1a500 DeggansMarks Options")

local DeggansMarksVertCheck = CreateFrame("CheckButton", "DeggansMarksVertCheck", DeggansMarksOptions.panel, "UICheckButtonTemplate")
DeggansMarksVertCheck:SetPoint("LEFT",DeggansMarksOptions.panel,"TOPLEFT",10,-50)
DeggansMarksVertCheck:SetSize(20,20)
DeggansMarksVertCheck:SetScript("OnClick", function(self) Defaults.vertical = not Defaults.vertical; DM_makeVertical() end)
local DeggansMarksVertText = DeggansMarksOptions.panel:CreateFontString("vertText", "OVERLAY", "ChatFontSmall")
DeggansMarksVertText:SetPoint("LEFT", DeggansMarksVertCheck , "RIGHT", 5,0)
DeggansMarksVertText:SetText("|cffe1a500 Display vertically")

local DeggansMarksBackgroundCheck = CreateFrame("CheckButton", "DeggansMarksBackgroundCheck", DeggansMarksOptions.panel, "UICheckButtonTemplate")
DeggansMarksBackgroundCheck:SetPoint("TOP",DeggansMarksVertCheck,"BOTTOM",0,-5)
DeggansMarksBackgroundCheck:SetSize(20,20)
DeggansMarksBackgroundCheck:SetScript("OnClick", function(self) Defaults.backgroundHide = not Defaults.backgroundHide; DM_backgroundChange() end)
local DeggansMarksBackgroundText = DeggansMarksOptions.panel:CreateFontString("DeggansMarksBackgroundText", "OVERLAY", "ChatFontSmall")
DeggansMarksBackgroundText:SetPoint("LEFT", DeggansMarksBackgroundCheck, "RIGHT", 5,0)
DeggansMarksBackgroundText:SetText("|cffe1a500 Hide background and border")

local DeggansMarksDisablerCheck = CreateFrame("CheckButton", "DeggansMarksDisablerCheck", DeggansMarksOptions.panel, "UICheckButtonTemplate")
DeggansMarksDisablerCheck:SetPoint("TOP",DeggansMarksBackgroundCheck,"BOTTOM",0,-5)
DeggansMarksDisablerCheck:SetSize(20,20)
DeggansMarksDisablerCheck:SetScript("OnClick", function(self) Defaults.disabled = not Defaults.disabled; DM_disable() end)
local DeggansMarksDisablerText = DeggansMarksOptions.panel:CreateFontString("DeggansMarksDisablerText", "OVERLAY", "ChatFontSmall")
DeggansMarksDisablerText:SetPoint("LEFT", DeggansMarksDisablerCheck, "RIGHT", 5,0)
DeggansMarksDisablerText:SetText("|cffe1a500 Disable DeggansMarks")

local DeggansMarksScale = CreateFrame("Slider", "DeggansMarksScale", DeggansMarksOptions.panel, "OptionsSliderTemplate")
DeggansMarksScale:SetPoint("TOPLEFT", DeggansMarksDisablerCheck, "BOTTOMLEFT",0,-25)
DeggansMarksScale:SetSize(180,16)
DeggansMarksScale:SetMinMaxValues(0.5,1.5)
DeggansMarksScale:SetValue(1)
DeggansMarksScale:SetValueStep(0.01)
DeggansMarksScale:SetOrientation("HORIZONTAL")
getglobal(DeggansMarksScale:GetName().."Low"):SetText("50%")
getglobal(DeggansMarksScale:GetName().."High"):SetText("150%")
getglobal(DeggansMarksScale:GetName().."Text"):SetText("Marker scale: "..math.floor((Defaults.markerScale*100)).."%")
DeggansMarksScale:SetValue(Defaults.markerScale)
DeggansMarksScale:SetScript("OnValueChanged", function(self) DM_scale(self, "main") end)
DeggansMarksScale:SetScript("OnLoad", function(self) DM_scale(self, "main") end)

local DeggansMarksScaleFlares = CreateFrame("Slider", "DeggansMarksScaleFlares", DeggansMarksOptions.panel, "OptionsSliderTemplate")
DeggansMarksScaleFlares:SetPoint("TOPLEFT", DeggansMarksScale, "BOTTOMLEFT",0,-25)
DeggansMarksScaleFlares:SetSize(180,16)
DeggansMarksScaleFlares:SetMinMaxValues(0.5,1.5)
DeggansMarksScaleFlares:SetValue(1)
DeggansMarksScaleFlares:SetValueStep(0.01)
DeggansMarksScaleFlares:SetOrientation("HORIZONTAL")
getglobal(DeggansMarksScaleFlares:GetName().."Low"):SetText("50%")
getglobal(DeggansMarksScaleFlares:GetName().."High"):SetText("150%")
getglobal(DeggansMarksScaleFlares:GetName().."Text"):SetText("Flares scale: "..math.floor((Defaults.flareScale*100)).."%")
DeggansMarksScaleFlares:SetValue(Defaults.flareScale)
DeggansMarksScaleFlares:SetScript("OnValueChanged", function(self) DM_scale(self, "flare") end)
DeggansMarksScaleFlares:SetScript("OnLoad", function(self) DM_scale(self, "flare") end)

-------------------------------------------------------
-- OnEvent
-------------------------------------------------------
local DM_OnUpdate = CreateFrame("Frame")
DM_OnUpdate:RegisterEvent("ADDON_LOADED")
DM_OnUpdate:RegisterEvent("PLAYER_LOGOUT")
DM_OnUpdate:RegisterEvent("PLAYER_LOGIN")
DM_OnUpdate:RegisterEvent("PLAYER_ENTERING_WORLD")
DM_OnUpdate:RegisterEvent("PLAYER_REGEN_DISABLED")
DM_OnUpdate:RegisterEvent("PLAYER_REGEN_ENABLED")

DM_OnUpdate:SetScript("OnEvent", function(self,event,addon,...)
	if (event=="PLAYER_LOGOUT" or event=="PLAYER_ENTERING_WORLD") then
		DM_SavePositions()
	end
	if (event=="PLAYER_LOGIN") then
		DM_SetPositions()
	end
	if (event=="PLAYER_REGEN_DISABLED") then
		isPullTimerStarted = false
		playerOutOfCombat = false
	end
	if (event=="PLAYER_REGEN_ENABLED") then
		isPullTimerStarted = false
		playerOutOfCombat = true
	end
end)

-------------------------------------------------------
-- Slash Commands
-------------------------------------------------------

SLASH_MB1 = '/DM'
SLASH_MB2 = '/DeggansMarks'
function SlashCmdList.MB(msg, editbox)
	local chan
	if (msg=="options") then
		InterfaceOptionsFrame_OpenToCategory(DeggansMarksOptions.panel)
		InterfaceOptionsFrame_OpenToCategory(DeggansMarksOptions.panel)
    elseif (msg=="options") then
	else
		DEFAULT_CHAT_FRAME:AddMessage("use /dm options to open configuration screen")
	end
end